import { __decorate } from "tslib";
import { filter, map } from 'rxjs/operators';
import { Subject } from 'rxjs';
import { Injectable } from '@angular/core';
export class EmitEvent {
    constructor(type, data) {
        this.type = type;
        this.data = data;
    }
}
export const addEvent = (it) => new EmitEvent(0 /* ADDED */, it);
export const changeEvent = (it) => new EmitEvent(1 /* CHANGED */, it);
export const removeEvent = (it) => new EmitEvent(2 /* REMOVED */, it);
export const errorEvent = (error) => new EmitEvent(3 /* ERROR */, error);
let EventBus = class EventBus {
    constructor() {
        this.emitter = new Subject();
    }
    emit(event) {
        this.emitter.next(event);
    }
    on(event, notify) {
        const watch$ = this.emitter.pipe(filter((e) => e.type === event), map((e) => e.data));
        return !notify ? watch$ : watch$.subscribe(notify);
    }
};
EventBus = __decorate([
    Injectable()
], EventBus);
export { EventBus };
//# sourceMappingURL=event-bus.js.map