import { ReplaySubject } from 'rxjs';
import { isElementRemoved } from './operators/until-view-destroyed';
/**
 * Auto-unsubscribe when the targeted element is removed from the DOM
 */
export function autoUnsubscribe(subscription, element) {
    if (typeof MutationObserver !== 'undefined') {
        var stop$ = new ReplaySubject();
        var hasBeenRemoved_1 = isElementRemoved(element);
        setTimeout(function () {
            var domObserver = new MutationObserver(function (records) {
                if (records.some(hasBeenRemoved_1)) {
                    subscription.unsubscribe();
                    domObserver.disconnect();
                }
            });
            domObserver.observe(element.parentNode, { childList: true });
        }, 20);
    }
}
//# sourceMappingURL=auto-unsubscribe.js.map