import { __decorate } from "tslib";
import { filter, map } from 'rxjs/operators';
import { Subject } from 'rxjs';
import { Injectable } from '@angular/core';
var EmitEvent = /** @class */ (function () {
    function EmitEvent(type, data) {
        this.type = type;
        this.data = data;
    }
    return EmitEvent;
}());
export { EmitEvent };
export var addEvent = function (it) { return new EmitEvent(0 /* ADDED */, it); };
export var changeEvent = function (it) { return new EmitEvent(1 /* CHANGED */, it); };
export var removeEvent = function (it) { return new EmitEvent(2 /* REMOVED */, it); };
export var errorEvent = function (error) { return new EmitEvent(3 /* ERROR */, error); };
var EventBus = /** @class */ (function () {
    function EventBus() {
        this.emitter = new Subject();
    }
    EventBus.prototype.emit = function (event) {
        this.emitter.next(event);
    };
    EventBus.prototype.on = function (event, notify) {
        var watch$ = this.emitter.pipe(filter(function (e) { return e.type === event; }), map(function (e) { return e.data; }));
        return !notify ? watch$ : watch$.subscribe(notify);
    };
    EventBus = __decorate([
        Injectable()
    ], EventBus);
    return EventBus;
}());
export { EventBus };
//# sourceMappingURL=event-bus.js.map