import { Subscription, Observable } from 'rxjs';
export declare const enum BusEventTypes {
    ADDED = 0,
    CHANGED = 1,
    REMOVED = 2,
    ERROR = 3
}
export declare class EmitEvent {
    type: BusEventTypes;
    data: any;
    constructor(type: BusEventTypes, data: any);
}
export declare const addEvent: (it: any) => EmitEvent;
export declare const changeEvent: (it: any) => EmitEvent;
export declare const removeEvent: (it: any) => EmitEvent;
export declare const errorEvent: (error: any) => EmitEvent;
export declare class EventBus {
    private emitter;
    emit(event: EmitEvent): void;
    on(event: BusEventTypes, notify: (data: any) => {}): Subscription | Observable<any>;
}
